﻿using System;
using System.Linq;
using System.Text;
using DevExpress.Xpo;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using DevExpress.Data.Filtering;
using DevExpress.Persistent.Base;
using System.Collections.Generic;
using DevExpress.ExpressApp.Model;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Persistent.Validation;
using DevExpress.ExpressApp.ConditionalAppearance;
using DevExpress.Xpo.Metadata;
using System.Drawing;
using DevExpress.ExpressApp.Security.Strategy;

namespace K12MIS.Module.BusinessObjects
{
    [DefaultClassOptions]
    //[ImageName("BO_Contact")]
    //[DefaultProperty("DisplayMemberNameForLookupEditorsOfThisType")]
    //[DefaultListViewOptions(MasterDetailMode.ListViewOnly, false, NewItemRowPosition.None)]
    //[Persistent("DatabaseTableName")]
    // Specify more UI options using a declarative approach (https://documentation.devexpress.com/#eXpressAppFramework/CustomDocument112701).
    public class Guardian : SecuritySystemUser
    { // Inherit from a different class to provide a custom primary key, concurrency and deletion behavior, etc. (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument113146.aspx).
        public Guardian(Session session)
            : base(session)
        {
        }
        public override void AfterConstruction()
        {
            base.AfterConstruction();
            // Place your initialization code here (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument112834.aspx).
        }
        //private string _PersistentProperty;
        //[XafDisplayName("My display name"), ToolTip("My hint message")]
        //[ModelDefault("EditMask", "(000)-00"), Index(0), VisibleInListView(false)]
        //[Persistent("DatabaseColumnName"), RuleRequiredField(DefaultContexts.Save)]
        //public string PersistentProperty {
        //    get { return _PersistentProperty; }
        //    set { SetPropertyValue("PersistentProperty", ref _PersistentProperty, value); }
        //}

        //[Action(Caption = "My UI Action", ConfirmationMessage = "Are you sure?", ImageName = "Attention", AutoCommit = true)]
        //public void ActionMethod() {
        //    // Trigger a custom business logic for the current record in the UI (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument112619.aspx).
        //    this.PersistentProperty = "Paid";
        //}
        string father;
        [Size(SizeAttribute.DefaultStringMappingFieldSize)]
        public string Father
        {
            get => father;
            set => SetPropertyValue(nameof(Father), ref father, value);
        }

        string fathersOccupation;
        [Size(SizeAttribute.DefaultStringMappingFieldSize)]
        public string FathersOccupation
        {
            get => fathersOccupation;
            set => SetPropertyValue(nameof(FathersOccupation), ref fathersOccupation, value);
        }


        string mother;
        [Size(SizeAttribute.DefaultStringMappingFieldSize)]
        public string Mother
        {
            get => mother;
            set => SetPropertyValue(nameof(Mother), ref mother, value);
        }

        string mothersOccupation;
        [Size(SizeAttribute.DefaultStringMappingFieldSize)]
        public string MothersOccupation
        {
            get => mothersOccupation;
            set => SetPropertyValue(nameof(MothersOccupation), ref mothersOccupation, value);
        }

        string address;
        [Size(SizeAttribute.DefaultStringMappingFieldSize)]
        public string Address
        {
            get => address;
            set => SetPropertyValue(nameof(Address), ref address, value);
        }


        string contactNo;
        [Size(SizeAttribute.DefaultStringMappingFieldSize)]
        public string ContactNo
        {
            get => contactNo;
            set => SetPropertyValue(nameof(ContactNo), ref contactNo, value);
        }


        string emailAddress;
        [Size(SizeAttribute.DefaultStringMappingFieldSize)]
        public string EmailAddress
        {
            get => emailAddress;
            set => SetPropertyValue(nameof(EmailAddress), ref emailAddress, value);
        }

        private Image fathersPhoto;
        [ImmediatePostData]
        [VisibleInListView(false)]
        [VisibleInLookupListView(false)]
        [ValueConverter(typeof(ImageValueConverter))]
        [FileTypeFilter("Image files", 2, "*.png", "*.jpg")]
        [Appearance("Appearance:Parent.FathersPhoto.UserCanEdit", Enabled = false, Criteria = "!UserCanEdit", Context = "DetailView")]
        [ImageEditor(ListViewImageEditorMode = ImageEditorMode.DropDownPictureEdit, DetailViewImageEditorMode = ImageEditorMode.DropDownPictureEdit)]
        public Image FathersPhoto
        {
            get { return this.fathersPhoto; }
            set { this.SetPropertyValue<Image>("FathersPhoto", ref this.fathersPhoto, value); }
        }


        //private Image mothersPhoto;
        //[ImmediatePostData]
        //[VisibleInListView(false)]
        //[VisibleInLookupListView(false)]
        //[ValueConverter(typeof(ImageValueConverter))]
        //[FileTypeFilter("Image files", 2, "*.png", "*.jpg")]
        //[Appearance("Appearance:Parent.MothersPhoto.UserCanEdit", Enabled = false, Criteria = "!UserCanEdit", Context = "DetailView")]
        //[ImageEditor(ListViewImageEditorMode = ImageEditorMode.DropDownPictureEdit, DetailViewImageEditorMode = ImageEditorMode.DropDownPictureEdit)]
        //public Image MothersPhoto
        //{
        //    get { return this.mothersPhoto; }
        //    set { this.SetPropertyValue<Image>("MothersPhoto", ref this.mothersPhoto, value); }
        //}

        [Association("Guardian-Students")]
        public XPCollection<Student> Students
        {
            get
            {
                return GetCollection<Student>(nameof(Students));
            }
        }


    }
}